<template>
  <div class="app-container">
    <!-- <el-form
        :model="queryParams"
        ref="queryForm"
        size="small"
        :inline="true"
        v-show="showSearch"
        label-width="68px"
      >
        <el-form-item label="登录地址" prop="ipaddr">
          <el-input
            v-model="queryParams.ipaddr"
            placeholder="请输入登录地址"
            clearable
            style="width: 240px"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="用户名称" prop="userName">
          <el-input
            v-model="queryParams.userName"
            placeholder="请输入用户名称"
            clearable
            style="width: 240px"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-select
            v-model="queryParams.status"
            placeholder="登录状态"
            clearable
            style="width: 240px"
          >
            <el-option
              v-for="dict in dict.type.sys_common_status"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="登录时间">
          <el-date-picker
            v-model="dateRange"
            style="width: 240px"
            value-format="yyyy-MM-dd HH:mm:ss"
            type="daterange"
            range-separator="-"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
            :default-time="['00:00:00', '23:59:59']"
          ></el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form> -->

    <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            @click="handleAllDelete"
            >删除</el-button
          >
        </el-col>
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
       
        <!-- <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            @click="handleClean"
            v-hasPermi="['monitor:logininfor:remove']"
            >清空</el-button
          >
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-unlock"
            size="mini"
            :disabled="single"
            @click="handleUnlock"
            v-hasPermi="['monitor:logininfor:unlock']"
            >解锁</el-button
          >
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="warning"
            plain
            icon="el-icon-download"
            size="mini"
            @click="handleExport"
            v-hasPermi="['monitor:logininfor:export']"
            >导出</el-button
          >
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar> -->
      </el-row>

    <el-table ref="tables" v-loading="loading" :data="list" @selection-change="handleSelectionChange">
      <!-- <el-table-column label="举报人" align="center" prop="nickName" width="100" /> -->
      <!-- <el-table-column
        label="举报时间"
        align="center"
        prop="createTime"
        width="200"
        :show-overflow-tooltip="true"
      /> -->
      <el-table-column type="selection" width="55" align="center" />

      <el-table-column
        label="名称"
        align="center"
        width="200"
        prop="activityName"
        :show-overflow-tooltip="true"
      />
      <!-- <el-table-column label="状态" align="center" prop="status" width="100">
        <template slot-scope="scope">
          {{
            scope.row.status === 0 ? "未审核" : scope.row.status === 1 ? "驳回" : "通过"
          }}
        </template>
      </el-table-column>
      <el-table-column
        label="举报标题"
        align="center"
        prop="productName"
        :show-overflow-tooltip="true"
      /> -->
      <el-table-column label="操作" align="center">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            >删除</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-close"
            @click="shwoEdite(scope.row)"
            >修改</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <!-- <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNumber"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    /> -->
    <el-dialog title="添加活动" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" label-width="120px">
        <el-row>
          <el-col :span="24">
            <el-form-item label="活动名称" required>
              <el-input
                v-model="form.addtext"
                type="input"
                placeholder="请输入活动名称"
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="onUpdateStatus">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-dialog title="编辑活动" :visible.sync="editOpen" width="600px" append-to-body>
      <el-form ref="form" :model="form" label-width="120px">
        <el-row>
          <el-col :span="24">
            <el-form-item label="编辑活动名称" required>
              <el-input
                v-model="editForm.activityName"
                type="input"
                placeholder="请输入活动名称"
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleEdit">确定修改</el-button>
        <el-button @click="cancelEdit">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { list, add, deleteActivity, deleteAllActivity, update } from "@/api/activity/index";

export default {
  name: "report",
  dicts: ["sys_common_status"],
  data() {
    return {
      open: false,
      editOpen: false,
      form: {
        addtext: "",
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 选择用户名
      selectName: "",
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 表格数据
      list: [],
      // 日期范围
      dateRange: [],
      // 默认排序
      defaultSort: { prop: "loginTime", order: "descending" },
      // 查询参数
      queryParams: {
        pageNumber: 1,
        pageSize: 10,
        ipaddr: undefined,
        userName: undefined,
        status: undefined,
      },
      deleteAllParams:[],
      editForm:{
        "activityName": "",
         "id": 0
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    cancelEdit(){
        this.editOpen = false
        this.editForm.activityName = ''
        this.editForm.id = ''
    },
    handleEdit(){
        update(this.addDateRange(this.editForm)).then((response) => {
          this.$modal.msgSuccess("编辑成功");
          this.getList();
          this.cancelEdit()
        });
    },
    shwoEdite(row){
        this.editOpen = true
        this.editForm.activityName = row.activityName
        this.editForm.id = row.id
    },
    handleSelectionChange(selection) {
        this.deleteAllParams = selection
    },

    handleAdd(){
        this.open = true
    },
    cancel() {
      this.form.addtext = "";
      this.open = false;
    },
    handleUpdateStatus(row, status) {
      this.form.productId = row.productId;
      this.form.type = row.type;
      this.form.status = status;
      if (status === 1) {
        this.open = true;
      } else {
        updateStatus(this.addDateRange(this.form)).then((response) => {
          this.$modal.msgSuccess("已通过");
          this.getList();
        });
      }
    },

    onUpdateStatus() {
      add(this.addDateRange({activityName: this.form.addtext})).then((response) => {
        this.$modal.msgSuccess("添加成功");
        this.getList();
        this.cancel();
      });
    },
    /** 查询登录日志列表 */
    getList() {
      this.loading = true;
      list(this.addDateRange(this.queryParams, this.dateRange)).then((response) => {
        this.list = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNumber = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.queryParams.pageNumber = 1;
      this.$refs.tables.sort(this.defaultSort.prop, this.defaultSort.order);
    },
    /** 多选框选中数据 */
    // handleSelectionChange(selection) {
    //   this.ids = selection.map((item) => item.infoId);
    //   this.single = selection.length != 1;
    //   this.multiple = !selection.length;
    //   this.selectName = selection.map((item) => item.userName);
    // },
    /** 排序触发事件 */
    handleSortChange(column, prop, order) {
      this.queryParams.orderByColumn = column.prop;
      this.queryParams.isAsc = column.order;
      this.getList();
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal
        .confirm("是否确认删除？")
        .then(function () {
          return deleteActivity({id:row.id, activityName:row.activityName });
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    handleAllDelete() {
        if(this.deleteAllParams.length === 0 ) {
            return this.$modal.msgSuccess("请选择需要删除的内容");
        }
      this.$modal
        .confirm("是否确认批量删除？")
        .then( () =>{
            debugger
          return deleteAllActivity(this.deleteAllParams);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 清空按钮操作 */
    handleClean() {
      this.$modal
        .confirm("是否确认清空所有登录日志数据项？")
        .then(function () {
          return cleanLogininfor();
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("清空成功");
        })
        .catch(() => {});
    },
    /** 解锁按钮操作 */
    handleUnlock() {
      const username = this.selectName;
      this.$modal
        .confirm('是否确认解锁用户"' + username + '"数据项?')
        .then(function () {
          return unlockLogininfor(username);
        })
        .then(() => {
          this.$modal.msgSuccess("用户" + username + "解锁成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "monitor/logininfor/export",
        {
          ...this.queryParams,
        },
        `logininfor_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
